export interface ConfirmationModalModuleOptions {
    okCallback: (confirmationModalModule: ConfirmationModalModule) => void;
    cancelCallback?: (confirmationModalModule: ConfirmationModalModule) => void;
    didShowCallback?: (confirmationModalModule: ConfirmationModalModule) => void;
    title: string;
    body: string;
    showCancelButton?: boolean;
    okButtonText?: string;
    cancelButtonText?: string;
    deleteOnHide?: boolean;
    showCommentField?: boolean;
    commentFieldIsRequired?: boolean;
    actionIsRequired?: boolean;
    appendToSelector?: string;
    size?: number;
    modalType?: ConfirmationModalType;
}
export declare const enum ConfirmationModalType {
    SlideIn = 1,
    Original = 2,
    Message = 3
}
export default class ConfirmationModalModule {
    $modalDiv: JQuery;
    private options;
    constructor(options: ConfirmationModalModuleOptions);
    show(): void;
    hide(): void;
    getCommentValue(): string | number | string[];
    delete(): void;
    private initialiseConfirmationModal;
}
