interface IInputStatusModuleSettings {
    /**
     * Position of the icon, when used on a div or span.
     */
    positionInDiv?: "top-center" | "center-right" | "top-right";
}
export default class InputStatusModule {
    private transisionEndEvent;
    private $originalElement;
    private $elementToCover;
    private $iconElement;
    private $iconWrapperElement;
    private originalHtml;
    private settings;
    constructor($element: JQuery, settings?: IInputStatusModuleSettings);
    showLoading(): void;
    showSuccess(): void;
    showWarning(): void;
    showError(): void;
    show(): void;
    hide(): void;
    removeWithFadeOut(doneCallback?: () => void): void;
    isVisible(): boolean;
    remove(): void;
    isInitialised(): boolean;
    private removeInputStatus;
    private setInputStatus;
    private createIconElement;
    private createIconElementForButton;
    private createIconElementForDiv;
    private createIconElementForTextInputWithInputGroup;
    private createIconElementForInput;
    private elementIsLinkOrButton;
    private elementIsDivOrParagraph;
    private elementIsTextInputWithInputGroup;
    private elementIsSelect2;
    private setElementEmptyState;
}
export {};
