/* eslint-disable no-undef */
/* eslint-disable @typescript-eslint/no-var-requires */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/*
 * ditmer-embla
 *
 */

"use strict";

module.exports = (grunt) => {

    grunt.registerMultiTask("ditmer_embla", "Create embla sass and icons", function() {

        var path = require("path");
        var currentPath = path.resolve(__dirname);

        var taskOptions = this.options();
        var taskData = this.data;
        var taskTarget = this.target;

        var getTaskOption = (optionName) => {

            var option = taskOptions[optionName];

            if (taskTarget && taskData) {
                var taskDataOption = taskData[optionName];
                if (taskDataOption)
                    option = taskDataOption;
            }

            return option;
        };

        var copyFilesToDirectory = (srcPath, destPath, pattern, fileType) => {

            // Create new application folder
            grunt.file.mkdir(destPath, "0444");

            // Return unique array of all file paths which match globbing pattern
            var options = { cwd: srcPath, filter: "isFile" };

            var copyCount = 0;
            grunt.file.expand(options, pattern).forEach((srcPathRelCwd) => {

                var copyFrom = path.join(srcPath, srcPathRelCwd);
                var copyTo = path.join(destPath, srcPathRelCwd);

                grunt.log.debug("Copy \"" + copyFrom + "\" to \"" + copyTo + "\"");

                grunt.file.copy(copyFrom, copyTo);
                copyCount++;
            });

            var logFunction = copyCount > 0 ? grunt.log.ok : grunt.log.warn;

            logFunction("Copied " + copyCount + " *" + fileType + "*" + (copyCount == 1 ? " file" : " files") + " from \"" + srcPath + "\"" + " to \"" + destPath + "\"");
        };


        var isDev = getTaskOption("dev");
        if(isDev) {
            grunt.log.warn("Running ditmer_embla in dev mode");
        }

        var emblaPackageDistPath = path.join(currentPath, isDev ? "../dev-dist" : "../dist");

        var cssOutputPath = getTaskOption("cssOutputPath");
        if(cssOutputPath && cssOutputPath.length > 0) {
            copyFilesToDirectory(path.join(emblaPackageDistPath, "css"), cssOutputPath, "**/*", "css");
        }

        var jsOutputPath = getTaskOption("jsOutputPath");
        if(jsOutputPath && jsOutputPath.length > 0) {
            copyFilesToDirectory(path.join(emblaPackageDistPath, "js"), jsOutputPath, "*", "js");
        }

        var fontsOutputPath = getTaskOption("fontsOutputPath");
        if(fontsOutputPath && fontsOutputPath.length > 0) {
            copyFilesToDirectory(path.join(emblaPackageDistPath, "fonts"), fontsOutputPath, "**/*", "font");
        }

        var iconsOutputPath = getTaskOption("iconsOutputPath");
        if(iconsOutputPath && iconsOutputPath.length > 0) {
            copyFilesToDirectory(path.join(emblaPackageDistPath, "icons"), iconsOutputPath, "*", "icon");
        }

        var illustrationsOutputPath = getTaskOption("illustrationsOutputPath");
        if(illustrationsOutputPath && illustrationsOutputPath.length > 0) {
            copyFilesToDirectory(path.join(emblaPackageDistPath, "illustrations"), illustrationsOutputPath, "*", "illustration");
        }

    });
};
